var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();

var i;
var j;

var Main =
{
    selectedVideo : 0,
    mode : 0,
    mute : 0,
    
    UP : 0,
    DOWN : 1,

    WINDOW : 0,
    FULLSCREEN : 1,
    
    NMUTE : 0,
    YMUTE : 1,
	
	ShowMode : 0,
	ErrorMessage : false,
	lastAction : null
}

Main.onLoad = function()
{
	window.onShow = function(){
		var nnaviPlugin = document.getElementById('pluginObjectNNavi');		
		nnaviPlugin.SetBannerState(2);
		pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
		pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
		pluginAPI.unregistKey(tvKey.KEY_MUTE);
	}

	i=0;
	j=0;

	document.getElementById("previous").style.backgroundImage ='url("Images/listBox/previous.png")';
	document.getElementById("next").style.backgroundImage ='url("Images/listBox/next.png")';
	
	Player.init();
	//Audio.init();
	Display.init();
	Server.init();
	
	Display.setTime(0);

	var nnaviPlugin = document.getElementById('pluginObjectNNavi');		
	nnaviPlugin.SetBannerState(2);
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
	
	this.enableKeys();
	widgetAPI.sendReadyEvent();
}

Main.onUnload = function()
{
	Player.deinit();
}

Main.updateCurrentVideo = function(move)
{
 	Player.setVideoURL( Data.getVideoURL(this.selectedVideo) );
    
    Display.setVideoListPosition(this.selectedVideo, move);

    Display.setDescription( Data.getVideoDescription(this.selectedVideo));
	Display.setFSB_Name( Data.getVideoName(this.selectedVideo));
}

Main.enableKeys = function()
{
    document.getElementById("anchor").focus();
}

Main.keyDown = function()
{
    Display.last_action_time=Display.curent_time;
	if(this.mode==this.FULLSCREEN){
		document.getElementById("full_screen_bar").style.display="block";
	}
	var keyCode = event.keyCode;
    switch(keyCode)
    {
		case tvKey.KEY_RETURN:
        case tvKey.KEY_PANEL_RETURN:
			widgetAPI.blockNavigation(event);
			Main.lastAction="return";
			if(this.ShowMode==0){
				widgetAPI.sendReturnEvent();
			}else if(this.ShowMode==1 && this.mode==this.FULLSCREEN){
				Main.lastAction="enter";
				document.getElementById("bg_img").src="Images/bg-.png";
				this.toggleMode();
				return;
			}else if(Main.ShowMode>0){
				if(Main.ErrorMessage!=true){
					if(Player.state!=Player.STOPPED)
						Player.stopVideo();
					while(this.selectedVideo!=0){
						this.selectPreviousVideo(this.UP);
					}
					document.getElementById("message").style.display="none";
					document.getElementById("main").style.display="none";
					document.getElementById("send_bar").style.display="none";
					document.getElementById("input").style.display="none";
					document.getElementById("center_bar").style.display="block";
					document.getElementById("about_bar").style.display="none";
					document.getElementById("bg").style.display="block";
					document.getElementById("bg_img").src="Images/bg.png";
					
					document.getElementById("info_bar").style.display="block";
					document.getElementById("info_bar_info").style.display="block";
					document.getElementById("info_bar_move").style.display="block";
					document.getElementById("info_bar_enter").style.display="block";
					document.getElementById("info_bar_up_down").style.display="none";
					document.getElementById("info_bar_fullscreen").style.display="none";
					document.getElementById("info_bar_clear").style.display="none";
					document.getElementById("info_bar_letters_numbers").style.display="none";
					document.getElementById("info_bar_return").style.display="block";
					
					document.getElementById("loading").style.display="none";
					Main.ShowMode=0;
					Main.ErrorMessage=false;
				}
			}
            break;
		case tvKey.KEY_RED:
			Main.lastAction="red";
			if(this.ShowMode==0){
				this.ShowMode=3;
				document.getElementById("main").style.display="none";
				document.getElementById("center_bar").style.display="none";
				document.getElementById("send_bar").style.display="block";
				document.getElementById("input").style.display="block";
				document.getElementById("bg").style.display="block";
				document.getElementById("bg_img").src="Images/bg.png";
				document.getElementById("about_bar").style.display="none";
				
				document.getElementById("info_bar").style.display="block";
				document.getElementById("info_bar_info").style.display="none";
				document.getElementById("info_bar_move").style.display="none";
				document.getElementById("info_bar_enter").style.display="none";
				document.getElementById("info_bar_up_down").style.display="none";
				document.getElementById("info_bar_fullscreen").style.display="none";
				document.getElementById("info_bar_clear").style.display="block";
				document.getElementById("info_bar_letters_numbers").style.display="block";
				document.getElementById("info_bar_return").style.display="block";
				InputBox.Init("input");
			}
            break;
        case tvKey.KEY_PLAY:
			this.lastAction="play";
			if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					document.getElementById("bg_img").src="Images/bg-.png";
					if(this.ShowMode==1 && this.mode!=this.FULLSCREEN)
						Player.setWindow();
					this.handlePlayKey();
				}
			}
            break;    
        case tvKey.KEY_STOP:
			this.lastAction="stop";
			if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					Player.stopVideo();
					Display.last_action_time=0;
				}
			}
            break;
        case tvKey.KEY_PAUSE:
			this.lastAction="pause";
			if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					Player.pauseVideo();
				}
			}
            break;
            
        case tvKey.KEY_FF:
			this.lastAction="ff";
   			if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					if(Player.getState() == Player.PLAYING){
						Player.skipForwardVideo();
						Display.last_action_time=Display.last_action_time*10/10+30000;
					}
				}
			}
            break;
        
        case tvKey.KEY_RW:
			this.lastAction="rw";
			if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					if(Player.getState() == Player.PLAYING){
						Player.skipBackwardVideo();
						Display.last_action_time=Display.last_action_time*10/10-30000;
					}
					if(Display.last_action_time<0){
						Display.last_action_time=0;
					}
				}
			}
            break;
        case tvKey.KEY_DOWN:
			//Main.lastAction="down";
			if(Main.ShowMode==0){
				if(i<1){
					i=i+1;
					this.Pres();
				}			
			} else if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					document.getElementById("bg_img").src="Images/bg+.png";
					if(Display.isInfoMode==0 && this.mode!=this.FULLSCREEN){
						Main.lastAction="down";
						Player.stopVideo();
						document.getElementById("loading").style.display="none";
						this.selectNextVideo(this.DOWN);
						document.getElementById("progressBar").style.width = "0%";
						document.getElementById("fsb_progressBar").style.width = "0%";
					} else {
						//Display.ScrollDown();
					}
				}
			} 
            break;
            
        case tvKey.KEY_UP:
			//Main.lastAction="up";
			if(Main.ShowMode==0){
				if(i>0){
					i=i-1;
					this.Pres();
				}			
			} else if(Main.ShowMode==1){
				if(Main.ErrorMessage!=true){
					document.getElementById("bg_img").src="Images/bg+.png";
					if(Display.isInfoMode==0 && this.mode!=this.FULLSCREEN){
						Main.lastAction="up";
						Player.stopVideo();
						document.getElementById("loading").style.display="none";
						this.selectPreviousVideo(this.UP);
						document.getElementById("progressBar").style.width = "0%";
						document.getElementById("fsb_progressBar").style.width = "0%";						
					} else {
						//Display.ScrollUp();
					}
				}
			} 
            break;
            
        case tvKey.KEY_LEFT:
			Main.lastAction="left";
			if(Main.ShowMode==0){
				if(j>0){
					j=j-1;
					this.Pres();
				}
			}
            break;
        case tvKey.KEY_RIGHT:
			Main.lastAction="right";
			if(Main.ShowMode==0){
				if(j<1){
					j=j+1;
					this.Pres();
				}
			}
            break;			
			
			//---Display.setTime(-1);
        case tvKey.KEY_ENTER:
        case tvKey.KEY_PANEL_ENTER:
			Main.lastAction="enter";
			if(this.ShowMode==0){
				if(Main.ErrorMessage==true){
				
					document.getElementById("message").style.display="none";
					Main.ErrorMessage=false;
				}else{
					this.setUrl();
					Server.fetchVideoList();
				}
			} else if(this.ShowMode==1){
				if(Main.ErrorMessage==true){
					if(Player.state!=Player.STOPPED)
						Player.stopVideo();
					while(this.selectedVideo!=0){
						this.selectPreviousVideo(this.UP);
					}
					Display.setTime(-1);
					document.getElementById("message").style.display="none";
				
					document.getElementById("main").style.display="none";
					document.getElementById("send_bar").style.display="none";
					document.getElementById("input").style.display="none";
					document.getElementById("center_bar").style.display="block";
					document.getElementById("about_bar").style.display="none";
					document.getElementById("bg").style.display="block";
					document.getElementById("bg_img").src="Images/bg.png";
					
					document.getElementById("info_bar").style.display="block";
					document.getElementById("info_bar_info").style.display="block";
					document.getElementById("info_bar_move").style.display="block";
					document.getElementById("info_bar_enter").style.display="block";
					document.getElementById("info_bar_up_down").style.display="none";
					document.getElementById("info_bar_fullscreen").style.display="none";
					document.getElementById("info_bar_clear").style.display="none";
					document.getElementById("info_bar_letters_numbers").style.display="none";
					document.getElementById("info_bar_return").style.display="block";
					Main.ShowMode=0;
					Main.ErrorMessage=false;
				}else{
					document.getElementById("bg_img").src="Images/bg-.png";
					this.toggleMode();
					this.handlePlayKey();
				}
			}
            break;
        case tvKey.KEY_EXIT:
			widgetAPI.blockNavigation(event);
			Main.lastAction="exit";
			if(this.state==Main.PLAYER){
				Player.stopVideo();
			}
			widgetAPI.sendExitEvent();
			break;
        default:
            break;
    }
}

Main.handlePlayKey = function()
{
    switch ( Player.getState() )
    {
        case Player.STOPPED:
            Player.playVideo();
			Display.last_action_time=0;
            break;
        case Player.PAUSED:
            Player.resumeVideo();
			Display.last_action_time=0;
            break;
        default:
            break;
    }
}

/*Main.handlePauseKey = function()
{
    switch ( Player.getState() )
    {
        case Player.PLAYING:
			Player.pauseVideo();
            break;     
        default:
            break;
    }
}*/

Main.selectNextVideo = function(down)
{
    Player.stopVideo();  
    this.selectedVideo = (this.selectedVideo + 1) % Data.getVideoCount();
    this.updateCurrentVideo(down);
}

Main.selectPreviousVideo = function(up)
{
    Player.stopVideo();
    
    if (--this.selectedVideo < 0)
    {
        this.selectedVideo += Data.getVideoCount();
    }

    this.updateCurrentVideo(up);
}

Main.setFullScreenMode = function()
{
    if (this.mode != this.FULLSCREEN)
    {
        Display.hide();
        
        Player.setFullscreen();
        
        this.mode = this.FULLSCREEN;
    }
}

Main.setWindowMode = function()
{
    if (this.mode != this.WINDOW)
    {
        Display.show();
        
        Player.setWindow();
        
        this.mode = this.WINDOW;
    }
}

Main.toggleMode = function()
{
    /*if(Player.getState() == Player.PAUSED)
    {
        Player.resumeVideo();
     }*/
    switch (this.mode)
    {
        case this.WINDOW:
            this.setFullScreenMode();
			document.getElementById("img_loading").style.left="50%";
            break;
            
        case this.FULLSCREEN:
            this.setWindowMode();
			document.getElementById("img_loading").style.left="70%";
            break;
            
        default:
            //alert("ERROR: unexpected mode in toggleMode");
            break;
    }
    if(Player.getState() == Player.PAUSED)
    {
        Player.plugin.Pause();
     }	
}


/*Main.setMuteMode = function()
{
    if (this.mute != this.YMUTE)
    {
        var volumeElement = document.getElementById("volumeInfo");
		var fsb_volumeElement = document.getElementById("fsb_volumeInfo");
        Audio.plugin.SetUserMute(true);
        document.getElementById("volumeBar").style.backgroundImage = "url(Images/videoBox/muteBar.png)";
        document.getElementById("volumeIcon").style.backgroundImage = "url(Images/videoBox/mute.png)";
		document.getElementById("fsb_volumeBar").style.backgroundImage = "url(Images/videoBox/muteBar.png)";
        document.getElementById("fsb_volumeIcon").style.backgroundImage = "url(Images/videoBox/mute.png)";
        widgetAPI.putInnerHTML(volumeElement, "MUTE");
		widgetAPI.putInnerHTML(fsb_volumeElement, "MUTE");
        this.mute = this.YMUTE;
    }
}*/

/*Main.noMuteMode = function()
{
    if (this.mute != this.NMUTE)
    {
		Audio.plugin.SetUserMute(false); 
        document.getElementById("volumeBar").style.backgroundImage = "url(Images/videoBox/volumeBar.png)";
        document.getElementById("volumeIcon").style.backgroundImage = "url(Images/videoBox/volume.png)";
        document.getElementById("fsb_volumeBar").style.backgroundImage = "url(Images/videoBox/volumeBar.png)";
        document.getElementById("fsb_volumeIcon").style.backgroundImage = "url(Images/videoBox/volume.png)";
        Display.setVolume( Audio.getVolume() );
        this.mute = this.NMUTE;
    }
}

Main.muteMode = function()
{
    switch (this.mute)
    {
        case this.NMUTE:
            this.setMuteMode();
            break;
            
        case this.YMUTE:
            this.noMuteMode();
            break;
            
        default:
            //alert("ERROR: unexpected mode in muteMode");
            break;
    }
}*/



Main.Pres = function()
{
document.getElementById("button1").src="Images/main/car_reviews.png";
document.getElementById("button2").src="Images/main/auto_show.png";
document.getElementById("button3").src="Images/main/crash_test.png";
document.getElementById("button4").src="Images/main/tuning.png";

	if(i==0 && j==0){
		document.getElementById("button1").src="Images/main/car_reviews_selected.png";
	}else if(i==0 && j==1){
		document.getElementById("button2").src="Images/main/auto_show_selected.png";
	}else if(i==1 && j==0){
		document.getElementById("button3").src="Images/main/crash_test_selected.png";
	}else if(i==1 && j==1){
		document.getElementById("button4").src="Images/main/tuning_selected.png";	
	}
}

Main.setUrl = function()
{
	if(i==0 && j==0){
		Server.setUrl("http://hivede11-1416.fornex.org/SmartTV_Cars/CarReviews/videoList.xml");
	}else if(i==0 && j==1){
		Server.setUrl("http://hivede11-1416.fornex.org/SmartTV_Cars/AutoShow/videoList.xml");
	}else if(i==1 && j==0){
		Server.setUrl("http://hivede11-1416.fornex.org/SmartTV_Cars/CrashTests/videoList.xml");
	}else if(i==1 && j==1){
		Server.setUrl("http://hivede11-1416.fornex.org/SmartTV_Cars/Tuning/videoList.xml");
	}
}
