var Player =
{
    plugin : null,
    state : 0,
    skipState : -1,
    stopCallback : null,
    originalSource : null,
    
    STOPPED : 0,
    PLAYING : 1,
    PAUSED : 2,  
    FORWARD : 3,
    REWIND : 4,
	BUFFERING : 5,
	
	paused : false
}

Player.init = function()
{
    var success = true; 
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    if (!this.plugin){
         success = false;
		 return success;
    }
    this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
    this.plugin.OnStreamInfoReady = 'Player.setTotalTime';
    this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';  

	this.plugin.OnConnectionFailed = 'Player.ConnectionError';
	this.plugin.OnNetworkDisconnected = 'Player.ConnectionError';
	this.plugin.OnRenderError = 'Player.ConnectionError';
	this.plugin.OnStreamNotFound = 'Player.ConnectionError';
	this.plugin.OnAuthenticationFailed ='Player.ConnectionError';	
	
	this.setWindow();
    return success;
}

Player.deinit = function()
{
	if (this.plugin){
		this.plugin.Stop();
	}
}

Player.setWindow = function()
{
    this.plugin.SetDisplayArea(458, 58, 472, 270);
}

Player.setFullscreen = function()
{
	this.plugin.SetDisplayArea(0, 0, 960, 540);
}

Player.setVideoURL = function(url)
{
    this.url = url;
}

Player.playVideo = function()
{
    if (this.url == null){
        alert("No videos to play");
    }else{
        pluginAPI.setOffScreenSaver();
        document.getElementById("play").style.opacity = '0.2';
        document.getElementById("stop").style.opacity = '1.0';
        document.getElementById("pause").style.opacity = '1.0';
        document.getElementById("forward").style.opacity = '1.0';
        document.getElementById("rewind").style.opacity = '1.0';

        document.getElementById("fsb_play").style.opacity = '0.2';
        document.getElementById("fsb_stop").style.opacity = '1.0';
        document.getElementById("fsb_pause").style.opacity = '1.0';
        document.getElementById("fsb_forward").style.opacity = '1.0';
        document.getElementById("fsb_rewind").style.opacity = '1.0';
		this.plugin.Play( this.url );
		//Display.status("Play");
		//this.state = this.PLAYING;
    }
}

Player.pauseVideo = function()
{
    if(this.state==this.PLAYING && document.getElementById("timeInfo").innerHTML!="0:00:00/0:00:00"){
		this.plugin.Pause();
		this.state = this.PAUSED;
		document.getElementById("play").style.opacity = '1.0';
		document.getElementById("stop").style.opacity = '1.0';
		document.getElementById("pause").style.opacity = '0.2';
		document.getElementById("forward").style.opacity = '0.2';
		document.getElementById("rewind").style.opacity = '0.2';
		
		document.getElementById("fsb_play").style.opacity = '1.0';
		document.getElementById("fsb_stop").style.opacity = '1.0';
		document.getElementById("fsb_pause").style.opacity = '0.2';
		document.getElementById("fsb_forward").style.opacity = '0.2';
		document.getElementById("fsb_rewind").style.opacity = '0.2';
		Display.status("Pause");
	}
}

Player.stopVideo = function()
{
    if (this.state != this.STOPPED)
    {
		this.plugin.Stop();
		this.state = this.STOPPED;
		document.getElementById("play").style.opacity = '1.0';
        document.getElementById("stop").style.opacity = '0.2';
        document.getElementById("pause").style.opacity = '0.2';
        document.getElementById("forward").style.opacity = '0.2';
        document.getElementById("rewind").style.opacity = '0.2';
		
        document.getElementById("fsb_play").style.opacity = '1.0';
        document.getElementById("fsb_stop").style.opacity = '0.2';
        document.getElementById("fsb_pause").style.opacity = '0.2';
        document.getElementById("fsb_forward").style.opacity = '0.2';
        document.getElementById("fsb_rewind").style.opacity = '0.2';

		document.getElementById("loading").style.display="none";
		document.getElementById("img_loading").style.left="70%";
		document.getElementById("bg_img").src="Images/bg+.png";
       
		Display.status("Stop");
        Main.setWindowMode();
		Display.setTime(-1);
    }
}



Player.stopPlayer = function()
{
	Player.stopVideo();
}

Player.resumeVideo = function()
{
    pluginAPI.setOffScreenSaver();
	this.state = this.PLAYING;
    document.getElementById("play").style.opacity = '0.2';
    document.getElementById("stop").style.opacity = '1.0';
    document.getElementById("pause").style.opacity = '1.0';
    document.getElementById("forward").style.opacity = '1.0';
    document.getElementById("rewind").style.opacity = '1.0';
	
    document.getElementById("fsb_play").style.opacity = '0.2';
    document.getElementById("fsb_stop").style.opacity = '1.0';
    document.getElementById("fsb_pause").style.opacity = '1.0';
    document.getElementById("fsb_forward").style.opacity = '1.0';
    document.getElementById("fsb_rewind").style.opacity = '1.0';
    Display.status("Play");
    this.plugin.Resume();
}

Player.skipForwardVideo = function()
{
    this.skipState = this.FORWARD;
    this.plugin.JumpForward(30);    
}

Player.skipBackwardVideo = function()
{
    this.skipState = this.REWIND;
    this.plugin.JumpBackward(30);
}

Player.getState = function()
{
    return this.state;
}

Player.onBufferingStart = function()
{
	this.state = this.BUFFERING;
	Display.status("Buffering...");
	document.getElementById("loading").style.display="block";
    switch(this.skipState)
    {
        case this.FORWARD:
            document.getElementById("forward").style.opacity = '0.2';
			document.getElementById("fsb_forward").style.opacity = '0.2';
            break;
        
        case this.REWIND:
            document.getElementById("rewind").style.opacity = '0.2';
			document.getElementById("fsb_rewind").style.opacity = '0.2';
            break;
    }
}

Player.onBufferingProgress = function(percent)
{
    this.state = this.BUFFERING;
	Display.status("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function()
{
	document.getElementById("forward").style.opacity = '1.0';
	document.getElementById("fsb_forward").style.opacity = '1.0';
	document.getElementById("rewind").style.opacity = '1.0';
	document.getElementById("fsb_rewind").style.opacity = '1.0';
	document.getElementById("loading").style.display="none";
}

Player.setCurTime = function(time)
{
    Display.setTime(time);
}

Player.setTotalTime = function()
{
    Display.setTotalTime(Player.plugin.GetDuration());
}

Player.ConnectionError = function()
{
	alert("ConnectionError");
	document.getElementById("bg_img").src="Images/bg+.png";
	Player.stopVideo();
	Display.last_action_time=0;
	Display.status("Error");
	Main.ErrorMessage=true;
	document.getElementById("mess").innerHTML="Ошибка соединения";
	document.getElementById("message").style.display="block";	
}

getBandwidth = function(bandwidth) { alert("getBandwidth " + bandwidth); }

onDecoderReady = function() { alert("onDecoderReady"); }

setTottalBuffer = function(buffer) { alert("setTottalBuffer " + buffer); }

setCurBuffer = function(buffer) { alert("setCurBuffer " + buffer); }
