var Server =
{
    dataReceivedCallback : null,
    
    XHRObj : null,
	Page: 1,
	url : null
}

Server.setUrl=function(url)
{
	this.url=url;
}

Server.init = function()
{
    var success = true;

    if (this.XHRObj)
    {
        this.XHRObj.destroy();  // Save memory
        this.XHRObj = null;
    }
    
    return success;
}

Server.dataReceivedCallback = function()
{	
	Display.setVideoList( Data.getVideoNames() );
	Main.updateCurrentVideo();
}

Server.fetchVideoList = function()
{
    if (this.XHRObj == null)
    {
        this.XHRObj = new XMLHttpRequest();
    }
    
    if (this.XHRObj)
    {
        this.XHRObj.onreadystatechange = function()
            {
                if (Server.XHRObj.readyState == 4)
                {
                    Server.createVideoList();
                }
            }
            
        this.XHRObj.open("GET", this.url, true);
        this.XHRObj.send(null);
     }
    else
    {
        alert("Failed to create XHR");
    }
}

Server.createVideoList = function()
{
    if (this.XHRObj.status != 200)
    {
		Main.ErrorMessage=true;
		document.getElementById("mess").innerHTML="Ошибка соединения";
		document.getElementById("message").style.display="block";
    }
    else
    {
        var xmlElement = this.XHRObj.responseXML.documentElement;
        
        if (!xmlElement)
        {
            alert("Failed to get valid XML");
        }
        else
        {
            var items = xmlElement.getElementsByTagName("item");
            
            var videoNames = [ ];
            var videoURLs = [ ];
            var videoDescriptions = [ ];
            var i=0;
			for (i=0;i<5;i++){
			}
			
            for (var index = 0; index < items.length; index++)
            {
                var titleElement = items[index].getElementsByTagName("title")[0];
                var descriptionElement = items[index].getElementsByTagName("description")[0];
                var linkElement = items[index].getElementsByTagName("link")[0];
                
                if (titleElement && descriptionElement && linkElement)
                {
                    videoNames[index] = titleElement.firstChild.data;
                    videoURLs[index] = linkElement.firstChild.data;
                    if(descriptionElement.firstChild.data.indexOf="."!=-1){
						videoDescriptions[index] = "<b>" + descriptionElement.firstChild.data.replace("." , "</b><br>");
					}else{
						videoDescriptions[index] = descriptionElement.firstChild.data;
					}
                }
            }
        
            Data.setVideoNames(videoNames);
            Data.setVideoURLs(videoURLs);
            Data.setVideoDescriptions(videoDescriptions);
            
            if (this.dataReceivedCallback)
            {
                this.dataReceivedCallback(); 
            }
        }
		document.getElementById("main").style.display="block";
		document.getElementById("center_bar").style.display="none";
		document.getElementById("bg_img").src="Images/bg+.png";
		document.getElementById("info_bar").style.display="block";
		document.getElementById("info_bar_info").style.display="none";
		document.getElementById("info_bar_move").style.display="none";
		document.getElementById("info_bar_enter").style.display="none";
		document.getElementById("info_bar_up_down").style.display="block";
		document.getElementById("info_bar_fullscreen").style.display="block";
		document.getElementById("info_bar_return").style.display="block";
		Main.ShowMode=1;
    }
}


